source: MondoRescue/branches/2.2.5/mindi/rootfs/sbin/init @ 1759

Last change on this file since 1759 was 1759, checked in by Bruno Cornec, 12 years ago

Tries to add udev support also for rhel4

  • Property svn:keywords set to Id
File size: 17.5 KB
Line 
1#!/bin/sh
2#
3# $Id: init 1759 2007-11-01 14:17:23Z bruno $
4#
5# init script launched during the restore process
6#------------------------------------------------------------
7
8
9CaughtSoftReset() {
10    trap SIGTERM
11    reboot
12}
13
14
15ConfigureLoggingDaemons() {
16    echo -en "Running klogd..."
17    klogd -c 2 > /dev/null 2> /dev/null
18    echo -en "Done.\nRunning syslogd..."
19    syslogd > /dev/null 2> /dev/null
20    echo "Done."
21    LogIt "klogd and syslogd have been started."
22}
23
24
25
26CopyBootDevEntry() {
27    local outfile devfile
28    devfile=/dev/boot_device
29    outfile=`cat /BOOTLOADER.DEVICE 2> /dev/null`
30    [ ! "$outfile" ] && return 0
31    echo -en "Copying boot device to $outfile..."
32    if [ -e "$outfile" ] ; then
33        echo "OK."
34        return 0
35    fi
36    mkdir -p $outfile
37    rmdir $outfile
38    cp -pRdf $devfile $outfile
39    if [ "$?" -ne "0" ] ; then
40        echo "Failed."
41        return 1
42    else
43        echo "OK."
44        return 0
45    fi
46}
47
48
49
50Die() {
51    LogIt "Fatal error! $1" 1
52    exit 1
53}
54
55
56
57ExtractDevTarballs() {
58    cd /
59    for fname in ataraid.tgz ida.tgz i2o.tgz rd.tgz raw.tgz cciss.tgz nst.tgz dm.tgz vc.tgz ; do
60        if [ ! -e "/$fname" ] ; then
61            LogIt "/$fname not found; cannot extract to /." 1
62        else
63            echo -en "\rExtracting /$fname...     "
64            tar -zxf /$fname || LogIt "Error occurred while extracting /$fname"
65        fi
66    done
67    echo -en "\r"
68    LogIt "Extracted additional /dev entries OK.     " 1
69}
70
71
72
73LaunchTerminals() {
74    openvt 2 /bin/sh
75    openvt 3 /bin/sh
76    openvt 4 /bin/sh
77    openvt 5 /bin/sh
78    openvt 6 /bin/sh
79    openvt 7 /bin/sh /sbin/wait-for-petris
80}
81
82
83LoadKeymap() {
84    local fname
85    fname=`cat /tmp/KEYMAP-LIVES-HERE 2> /dev/null`
86    [ "$fname" = "" ] && return
87    if which loadkeys > /dev/null 2> /dev/null ; then
88        loadkeys $fname
89# loadkmap != loadkeys
90#    elif which loadkmap > /dev/null 2> /dev/null ; then
91#        loadkmap < $fname
92    else
93        LogIt "Using default keyboard map." 1
94    fi
95}
96
97
98UntarTapeStuff() {
99    local old_pwd res
100    old_pwd=`pwd`
101    cd $GROOVY
102    [ "$1" != "" ] && tapedev=$1
103    [ ! "$tapedev" ] && tapedev=`grep media-dev /tmp/mondo-restore.cfg | tr -s ' ' ' ' | cut -d' ' -f2`
104#    tar -zxf $tapedev
105    dd if=$tapedev bs=32k count=1024 | tar -zx
106    res=$?
107    if [ "$res" -eq "0" ] ; then
108        grep -v media-dev /tmp/mondo-restore.cfg > /tmp/mr.cfg
109        echo "media-dev $tapedev" >> /tmp/mr.cfg
110        cp -f /tmp/mr.cfg /tmp/mondo-restore.cfg
111    fi
112    cd $old_pwd
113    return $res
114}
115
116HandleTape() {
117    local res tapedev
118    tapedev="" ; # will be set by UntarTapeStuff()
119    cd $GROOVY
120    UntarTapeStuff $tapedev || UntarTapeStuff /dev/st0 || UntarTapeStuff /dev/osst0 || UntarTapeStuff /dev/ht0
121    res=$?
122    while [ "$res" -ne "0" ] ; do
123        LogIt "$tapedev failed to act as extended data disk for booting." 1
124        LogIt "Please specify an alternate tape device," 1
125        LogIt "or hit <Enter> to boot from CD/floppies." 1
126        echo -en "---> "
127        read tapedev
128        if [ "$tapedev" ] ; then
129            LogIt "User specified $tapedev instead"
130            UntarTapeStuff $tapedev
131            res=$?
132        else
133            LogIt "User opted not to specify an alternate tapedev"
134            res=1
135        break
136        fi
137    done
138
139    if [ "$res" -ne "0" ] ; then
140        cd /
141        LogIt "Failed to use tape as extended datadisk. Reverting to floppies." 1
142        HandleCDROMorFloppies
143        res=$?
144    else
145#       clear
146        LogIt "Using tape as extended datadisk. Good." 3
147        echo "Using tape as extd ddisk." > /tmp/TAPEDEV-HAS-DATA-DISKS
148        res=0
149        CD_MOUNTED_OK=yes
150    fi
151    return $res
152}
153
154
155
156HandleCDROMorFloppies() {
157    find-and-mount-cdrom
158    res=$?
159    if [ "$res" -ne "0" ] ; then
160        LogIt "First call to find-and-mount-cdrom failed." 1
161        LogIt "Sleeping for 3 seconds and trying again." 1
162        sleep 3
163        find-and-mount-cdrom
164        res=$?
165    fi
166    if [ "$res" -eq "0" ] ; then
167        LogIt "OK, I am running on a CD-ROM. Good." 3
168        CD_MOUNTED_OK=yes
169    elif [ "$res" -eq "1" ] ; then
170        LogIt "OK, I am running on floppies. Good." 3
171        CD_MOUNTED_OK=""
172    else
173        LogIt "OK, I am falling back to floppy mode." 3
174        LogIt "That means you'll have to copy the data disk images from" 3
175        LogIt "the CD/hard disk/whatever to physical 1.44MB disks and" 3
176        LogIt "insert them, one after the other. Please see the manual." 3
177        LogIt "The images are in /images on the CD, or /root/images/mindi" 3
178        LogIt "on your hard disk. Your archives are probably fine but" 3
179        LogIt "your tape streamer and/or CD-ROM drive are eccentric. :-)" 3
180        CD_MOUNTED_OK=""
181    fi
182    return 0
183}
184
185
186HowMuchFreeSpaceOnRamdisk() {
187   df -m -P | grep /dev/ram | head -n1 | tr -s '\t' ' ' | cut -d' ' -f4
188}
189
190
191
192InsertEssentialModules() {
193#   Load the VIA IDE module first thing if it exists (requires ide-core).
194#   This is to ensure that DMA is working for VIA chipsets with 2.6 kernels.
195    for module in /ide-core.ko /via82cxxx.ko; do
196        [ -f "$module" ] && MyInsmod $module > /dev/null 2> /dev/null
197    done
198#   Then load the remaining modules in normal (i.e. arbitrary) order.
199    for j in 1 2 3 4 5 ; do
200        for i in `ls /*.*o* 2> /dev/null` ; do
201            [ -f "$i" ] && MyInsmod $i > /dev/null 2> /dev/null
202        done
203    done
204}
205
206
207
208PauseForRaids() {
209    if [ "`dmesg | grep -i "RAID Controller"`" != "" ] || [ "`dmesg | grep -i "Vendor: 3ware"`" != "" ] ; then
210        LogIt "RAID controller(s) detected. Pausing 10 seconds to let them warm up." 1
211        echo -en "Pausing..."
212        for i in 1 2 3 4 5 6 7 8 9 10 ; do
213            sleep 1
214            echo -en "$(($i*10))%..."
215        done
216        echo "Done."
217    fi
218}
219
220
221# 06/13/2002 --- DuckX's & Hugo's new routine
222# 10/11/2003 --- added a simple devfsd.conf file
223# 01/24/2005 --- cater for arbitrary locations of devfsd.conf by using the
224#                config file path compiled into devfsd
225RunDevfsd() {
226    loc=`which devfsd 2> /dev/null`
227    if [ "$loc" != "" ] ; then
228    LogIt "Devfs found. Testing kernel support..."
229    if [ ! -e "/dev/.devfsd" ] ; then
230        mount -t devfs devfs /dev 2>> $LOGFILE
231            if [ "$?" -ne "0" ] ; then
232        LogIt "Error while trying to mount devfs"
233        else
234        LogIt "Devfs mounted OK"
235        fi
236    fi
237    #check if the kernel supports devfs
238    if [ -e "/dev/.devfsd" ] ; then
239        [ -d "/proc/1" ] || mount -n /proc
240        LogIt "Kernel support found. Creating config file and starting devfsd"
241        conffile=`strings $loc | grep -E "devfsd.conf$"`
242        [ "$conffile" ] || conffile="/etc/devfsd.conf"
243        confpath=`echo $conffile | sed "s/\/devfsd\.conf$//"`
244        [ -d "$confpath" ] || mkdir -p $confpath
245        echo -en "REGISTER .* MKOLDCOMPAT\nUNREGISTER .* RMOLDCOMPAT\n" > $conffile
246        devfsd /dev &
247        sleep 5
248    else
249        LogIt "No devfs kernel support."
250    fi
251    fi
252}
253
254# Taken from udev management in Mandriva 2008.0. Kudos guys
255make_extra_nodes () {
256    # there are a few things that sysfs does not export for us.
257    # these things are listed in /etc/udev/links.conf
258    grep '^[^#]' /etc/udev-links.conf | \
259    while read type name arg1; do
260        [ "$type" -a "$name" -a ! -e "/dev/$name" -a ! -L "/dev/$name" ] ||continue
261        case "$type" in
262            L) ln -s $arg1 /dev/$name ;;
263            D) mkdir -p /dev/$name ;;
264            M) mknod /dev/$name $arg1 && chmod 600 /dev/$name;;
265            *) echo "udev-links.conf: unparseable line (%s %s %s)\n" "$type" "$name" "$arg1" ;;
266        esac
267    done
268}
269
270
271RunUdevd() {
272    # Inspiration from Mandriva 2008.0 startup script
273    echo "Preparing udev environment..."
274    mv /dev /dev.static
275    mkdir /dev
276    mount -n -o size=5M,mode=0755 -t tmpfs none /dev
277    make_extra_nodes
278    mount -n -t devpts -o mode=620 none /dev/pts
279    mount -n -t tmpfs  none /dev/shm
280    PKLVL=`cut -f1 /proc/sys/kernel/printk`
281    echo 0 > /proc/sys/kernel/printk
282    if [ -x /sbin/startudev ]; then
283        /sbin/startudev
284    fi
285    # Depending on udevd version it gives back the hand or not :-(
286    /sbin/udevd --daemon &
287    sleep 2
288    echo $PKLVL > /proc/sys/kernel/printk
289    # May avoid shell error messages
290    chmod 644 /dev/tty*
291}
292
293
294
295
296#RunDevfsd() {
297#    loc=`which devfsd 2> /dev/null`
298#    if [ "$loc" != "" ] ; then
299#        LogIt "Starting devfsd"
300#        devfsd /dev &
301#        sleep 5
302#    fi
303#}
304
305
306
307SpaceTests() {
308    [ -e "/tmp/filelist.full" ] && cp /tmp/filelist.full /tmp/FLF
309    if [ "`HowMuchFreeSpaceOnRamdisk`" -le "3" ] ; then
310        LogIt "Ramdisk is a bit smaller than I would like." 1
311        LogIt "Please re-run Mondo/Mindi but edit /usr/local/mindi first" 1
312        LogIt "and set EXTRA_SPACE to something high, e.g. 8000" 1
313        Die "Aborting. Please reboot."
314    fi
315    rm -f /tmp/FLF
316}
317
318
319
320StartLvms() {
321    if [ -e "/tmp/i-want-my-lvm" ] ; then
322        LogIt "Scanning LVM's..." 1
323        if which lvm ; then
324            MyInsmod dm-mod
325            MyInsmod dm_mod
326            lvm vgscan --mknodes
327        else
328            vgscan
329        fi
330        grep -E "^#.*vgchange" /tmp/i-want-my-lvm | sed "s/^#[ ]*//" > /tmp/start-lvm
331        chmod +x /tmp/start-lvm
332        echo -en "Starting LVM's..."
333        /tmp/start-lvm &
334        for i in 1 2 3 4 5 ; do
335            echo -en "."
336            sleep 1
337        done
338        echo "Done."
339    fi
340# If necessary, cannibalize 'analyze-my-lvm'; copy some of its code here,
341# pipe vgscan's output, strip it, run 'vgchange' on its output, etc.etc.
342    LogIt "LVM's have been started."
343}
344
345
346StartRaids() {
347    local raid_devices i
348
349    raid_devices=`grep /dev/md /tmp/mountlist.txt | cut -d' ' -f1`
350    if which raidstart > /dev/null 2> /dev/null ; then
351        for i in $raid_devices ; do
352            if grep `basename $i` /proc/mdstat > /dev/null 2> /dev/null ; then
353                LogIt "$i is started already; no need to run 'raidstart $i'" 1
354            else
355                LogIt "Running 'raidstart $i'" 1
356                raidstart $i
357            fi
358        done
359    elif which mdrun > /dev/null 2> /dev/null ; then
360        LogIt "Running 'mdrun'" 1
361        mdrun
362    elif which mdadm > /dev/null 2> /dev/null ; then
363        LogIt "Running 'mdadm'" 1
364        for i in $raid_devices ; do
365            if grep `basename $i` /proc/mdstat > /dev/null 2> /dev/null ; then
366                LogIt "$i is started already; no need to run 'mdadm $i'" 1
367            else
368                if [ -f /etc/mdadm.conf ] ; then
369                    LogIt "Running 'mdadm $i' with user supplied /etc/mdadm.conf" 1
370                    mdadm -A $i -c /etc/mdadm.conf
371                elif [ -f /etc/mdadm/mdadm.conf ] ; then
372                    LogIt "Running 'mdadm $i' with user supplied /etc/mdadm/mdadm.conf" 1
373                    mdadm -A $i -c /etc/mdadm/mdadm.conf
374                else
375                    LogIt "Running 'mdadm $i'" 1
376                    mdadm -Ac partitions -m dev $i
377                fi
378            fi
379        done
380    else
381        LogIt "Warning: Neither 'raidstart' nor 'mdrun''found. RAID devices may not have started." 1
382    fi
383
384}
385
386
387TryAgainToFindCD() {
388    local res
389    mount | grep /mnt/cdrom && return 0
390    [ "`grep "backup_media_type" /tmp/mondo-restore.cfg | grep "cdstream"`" ] && return
391    LogIt "Trying to mount CD-ROM a 2nd time..."
392    find-and-mount-cdrom --second-try
393    res=$?
394    if [ "$res" -eq "0" ] ; then
395        CD_MOUNTED_OK=yes
396        LogIt "CD-ROM drive mounted successfully." 1
397    else
398        LogIt "I still cannot find or mount the CD-ROM drive, by the way."
399    fi
400}
401
402
403
404UseTmpfs()
405{
406    local mount_cmd
407    echo -en "Mounting /tmp/tmpfs..."
408    mkdir -p /tmp/tmpfs
409# For technical reasons, some sets are as large as 16MB.
410# I am allowing 32MB because selective restore occupies a lot of space.
411    for size in 64m 48m 40m 32m ; do
412        mount_cmd="mount /dev/shm -t tmpfs -o size=$size" ; # was 34m until 04/2003
413        LogIt "Trying '$mount_cmd'"
414        $mount_cmd /tmp/tmpfs 2>> $LOGFILE
415        res=$?
416        [ "$res" -eq "0" ] && break
417    done
418    if [ "$res" -ne "0" ] ; then
419        LogIt "Failed. I could not run '$mount_cmd /tmp/tmpfs'. Your kernel is BROKEN or you do not have enough RAM." 1
420        umount /tmp/tmpfs > /dev/null 2> /dev/null
421        rmdir /tmp/tmpfs
422        ln -sf /mnt/RESTORING/tmp /tmp/tmpfs; # used by mondo-restore
423        LogIt "Failed to mount /tmp/tmpfs; using ugly softlink instead"
424    else
425        LogIt "Great. Pivot succeeded w/ size=$size" 1
426        echo -en "Pivoting /tmp..."
427        umount /tmp/tmpfs
428        mkdir -p /tmp.old
429        mv /tmp/* /tmp.old/
430        # Try to Deal with a busybox bug on inexistant links
431        cp /tmp/* /tmp.old/
432        rm -f /tmp/*
433        $mount_cmd /tmp
434        mv /tmp.old/* /tmp/
435        # Try to Deal with a busybox bug on inexistant links
436        cp /tmp.old/* /tmp/
437        rm -rf /tmp.old
438        mkdir -p /tmp/tmpfs
439        mkdir -p $GROOVY
440    echo "Done."
441    LogIt "Successfully mounted dynamic /tmp ramdisk"
442#   mkdir -p /tmp/tmpfs/var
443#        mv -f /var/log /tmp/tmpfs/var/log
444#        ln -sf /tmp/tmpfs/var/log /var/log
445    fi
446}
447
448
449WelcomeMessage()
450{
451    echo "********************************************************************"
452    echo "MINDI-LINUX by Mondo Dev Team - web site: http://www.mondorescue.org"
453    echo "Boot disk based on AlfaLinux & Trinux. BusyBox by Erik Andersen."
454which petris > /dev/null 2> /dev/null && echo "Petris was written by Peter Seidler <p.seidler@mail1.stofanet.dk>."
455    echo "Executables and source code are covered by the GNU GPL. No warranty."
456    echo "running on $ARCH"
457    echo "********************************************************************"
458}
459
460
461EnableCcissIfAppropriate() {
462    local i fname
463    for i in 0 1 2 3 ; do
464        fname="/proc/driver/cciss/cciss$i"
465        if [ -e "$fname" ] ; then
466            LogIt "Engaging $fname"
467            echo "engage scsi" > $fname
468            LogIt "...result=$?"
469        fi
470    done
471}
472
473
474ExtractDataDisksAndLoadModules() {
475    echo "Installing additional tools ..."
476    install-additional-tools
477    echo "Inserting modules ..."
478    # Keep the kernel silent again
479    PKLVL=`cut -f1 /proc/sys/kernel/printk`
480    echo 0 > /proc/sys/kernel/printk
481    insert-all-my-modules >> $LOGFILE 2>> $LOGFILE
482    echo $PKLVL > /proc/sys/kernel/printk
483}
484
485# ------------------------ main -----------------------
486
487MINDI_VER=PBVER
488MINDI_REV=PBREV
489trap CaughtSoftReset SIGTERM
490LOGFILE=/var/log/mondorestore.log
491PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/mondo:/usr/games
492GROOVY=/tmp/groovy-stuff
493USER=root
494export PATH GROOVY USER LOGFILE
495
496echo "Welcome to init (from mindi ${MINDI_VER}-r${MINDI_REV})"
497
498mount -o remount rw /
499[ ! "$GROOVY" ] && Die "I'm not groovy!"
500for i in $GROOVY /mnt/floppy /mnt/cdrom /mnt/isodir /var/local/petris /tmp/isodir; do
501    mkdir -p $i
502done
503#/bin/update
504mount /proc/ /proc -v -t proc
505mkdir /sys 2> /dev/null
506mount /sys/ /sys -v -t sysfs 2>> $LOGFILE
507rm -f /foozero
508
509if [ -f /proc/sys/kernel/exec-shield ]; then
510    echo 0 > /proc/sys/kernel/exec-shield 2>> /dev/null
511fi
512
513if [ -f /proc/modules ]; then
514    echo "/sbin/modprobe" > /proc/sys/kernel/modprobe
515fi
516
517if [ -e "/tmp/USE-UDEV" ] ; then
518    RunUdevd
519else
520    ExtractDevTarballs
521fi
522LaunchTerminals
523
524# Keeping kernel silent  for module insertion
525PKLVL=`cut -f1 /proc/sys/kernel/printk`
526echo 0 > /proc/sys/kernel/printk
527InsertEssentialModules
528echo $PKLVL > /proc/sys/kernel/printk
529
530EnableCcissIfAppropriate
531#-------------------------------
532#WHOLIVESINAPINEAPPLEUNDERTHESEA#;# --- don't touch this :)
533#-------------------------------
534UseTmpfs
535if [ ! -e "/tmp/mondo-restore.cfg" ] ; then
536    LogIt "Warning - /tmp/mondo-restore.cfg not found"
537fi
538
539if [ "`grep -i 'tape ' /tmp/mondo-restore.cfg`" ] || [ "`grep -i udev /tmp/mondo-restore.cfg`" ]; then
540    HandleTape
541    ExtractDataDisksAndLoadModules
542elif [ "`grep -i pxe /proc/cmdline`" ]; then
543    # We need to get here exported variables from start-nfs
544    . /sbin/start-nfs
545
546    # Simulate a local CD
547    echo "/mnt/cdrom" > /tmp/CDROM-LIVES-HERE
548    CD_MOUNTED_OK=yes
549    ExtractDataDisksAndLoadModules
550elif [ "`grep -i usb= /proc/cmdline`" ] || [ "`grep -i usb /tmp/mondo-restore.cfg | grep media-type`" ]; then
551    # We need to get here exported variables from start-nfs
552    . /sbin/start-usb
553
554    # Simulate a local CD
555    echo "/mnt/cdrom" > /tmp/CDROM-LIVES-HERE
556    CD_MOUNTED_OK=yes
557    ExtractDataDisksAndLoadModules
558else
559    HandleCDROMorFloppies
560    ExtractDataDisksAndLoadModules
561    # We need to get here exported variables from start-nfs
562    . /sbin/start-nfs
563fi
564res=$?
565ConfigureLoggingDaemons
566if [ -e "/tmp/USE-DEVFS" ] ; then
567    umount /mnt/cdrom 2> /dev/null
568    mv /dev/cdrom /cdrom.lnk 2> /dev/null
569    CD_MOUNTED_OK=""
570    RunDevfsd
571fi
572echo "Starting potential Raid/LVMs ..."
573PauseForRaids
574StartRaids
575StartLvms
576CopyBootDevEntry
577LoadKeymap
578mkdir -p /tmp/tmpfs
579sleep 2
580#clear
581if [ -e "/dev/md0" ] && [ ! -e "/dev/md/0" ] && [ "`grep /dev/md/ /tmp/mountlist.txt`" != "" ] ; then
582    LogIt "Creating /dev/md/* softlinks just in case." 1
583    mkdir -p /dev/md
584    cp -af /dev/md0 /dev/md/0 2> /dev/null
585    cp -af /dev/md1 /dev/md/1 2> /dev/null
586    cp -af /dev/md2 /dev/md/2 2> /dev/null
587fi
588export ARCH=`uname -m`
589WelcomeMessage
590# SpaceTests; # Mandrake Linux 8.1 doesn't like this
591[ -e "/tmp/mountlist.txt" ] && cp -f /tmp/mountlist.txt /tmp/mountlist.original
592
593if ! [ "`grep -i "pxe" /proc/cmdline`" ] ; then
594    res="`cat /mnt/cdrom/archives/THIS-CD-NUMBER 2> /dev/null`"
595    [ "$res" != "1" ] && [ "$res" != "" ] && Die "This is CD #$res in the series. Please insert CD #1."
596    [ -e "/cdrom.lnk" ] && mv -f /cdrom.lnk /dev/cdrom && mount /dev/cdrom /mnt/cdrom && CD_MOUNTED_OK=yes
597    [ "$CD_MOUNTED_OK" != "yes" ] && TryAgainToFindCD
598    #mount | grep cdrom > /dev/null 2> /dev/null || mount /dev/cdrom /mnt/cdrom >> $LOGFILE 2>> $LOGFILE
599fi
600hack-cfg-if-necessary || LogIt "Cannot find hack-cfg-if-necessary"
601openvt 8 /usr/bin/tail -f $LOGFILE
602
603# Log some useful info
604LogIt "init (from mindi v$MINDI_VER-r${MINDI_REV}"
605LogIt "/proc/cmdline is:"
606cat /proc/cmdline  >> $LOGFILE
607LogIt "df result:"
608LogIt "----------"
609df >> $LOGFILE
610LogIt "-------------"
611LogIt "mount result:"
612LogIt "-------------"
613mount >> $LOGFILE
614LogIt "-------------"
615LogIt "lsmod result:"
616LogIt "-------------"
617lsmod >> $LOGFILE
618LogIt "-------------"
619LogIt "dmesg result:"
620LogIt "-------------"
621dmesg >> $LOGFILE
622
623#-------------------------------
624#ABSORBENTANDYELLOWANDPOROUSISHE#;# --- don't touch this either :)
625#-------------------------------
626
627#ctrlaltdel soft
628for path in /usr.bin /usr/bin ; do
629    fname=$path/nano
630    [ -e "$fname" ] && ln -sf $fname /usr/bin/pico
631done
632res=`which nano 2> /dev/null`
633[ "$res" ] && ln -sf /usr/bin/
634for i in null stdout stdin stderr ; do
635    cp -af /dev/$i /tmp
636done
637if grep "backup-media-type" /tmp/mondo-restore.cfg > /dev/null 2> /dev/null ; then
638    LogIt "backup-media-type is specified in config file - great."
639    LogIt "Calling post-init $mountlist"
640    post-init
641else
642    LogIt "backup-media-type is not specified in config file."
643    LogIt "I think this CD/floppy has no archives on it."
644fi
645if grep "RESTORE" /proc/cmdline > /dev/null 2> /dev/null ; then
646    echo "Rebooting in 10 seconds automatically as per reboot order"
647    echo -en "Press ^C to interrupt if you have to ..."
648    for i in 1 2 3 4 5 6 7 8 9 10 ; do
649        sleep 1
650        echo -en "."
651    done
652    echo "Boom."
653    sleep 1
654else
655    echo -en "Type 'exit' to reboot the PC\n"
656    umount /mnt/cdrom 2> /dev/null
657    mount / -o rw,remount > /dev/null 2> /dev/null
658    LogIt "Launching Shell"
659    sh
660fi
661CaughtSoftReset
662# reboot
Note: See TracBrowser for help on using the repository browser.